package com.link.core.util;

import com.google.zxing.BarcodeFormat;
import com.google.zxing.EncodeHintType;
import com.google.zxing.MultiFormatWriter;
import com.google.zxing.client.j2se.MatrixToImageWriter;
import com.google.zxing.common.BitMatrix;
import com.swetake.util.Qrcode;
import java.awt.Color;
import java.awt.Graphics2D;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.IOException;
import java.util.Map;
import java.util.Random;
import javax.imageio.ImageIO;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;

public class QRCodeUtil {
   static int width = 180;
   static int height = 180;
   private static final int BLACK = -16777216;
   private static final int WHITE = -1;
   private static final Logger logger = LogManager.getLogger(QRCodeUtil.class);

   public static void tomakeMode(String strJson, String path, String fileName, int width, int height) {
      System.out.println("**********************创建二维码存放路径*********************************");
      System.out.println("**********************创建二维码存放路径*********************************");
      System.out.println("**********************创建二维码存放路径*********************************");
      File file = new File(path);
      if (!file.exists()) {
         file.mkdirs();
      }

      try {
         File qpImg = new File(path + fileName);
         encode(strJson, qpImg, "png", BarcodeFormat.QR_CODE, width, height, (Map)null);
         System.out.println("**********************创建二维码成功*********************************");
         System.out.println("**********************创建二维码成功*********************************");
         System.out.println("**********************创建二维码成功*********************************");
      } catch (Exception var7) {
         Exception e = var7;
         logger.error("QRCodeUtil捕获异常: ", e);
      }

   }

   public static BufferedImage tomakeMode(String contents, BarcodeFormat format, int width, int height) throws Exception {
      contents = new String(contents.getBytes("UTF-8"), "ISO-8859-1");
      BitMatrix bitMatrix = (new MultiFormatWriter()).encode(contents, format, width, height);
      return MatrixToImageWriter.toBufferedImage(bitMatrix);
   }

   public static void encode(String contents, File file, String filePostfix, BarcodeFormat format, int width, int height, Map<EncodeHintType, ?> hints) {
      try {
         contents = new String(contents.getBytes("UTF-8"), "ISO-8859-1");
         BitMatrix bitMatrix = (new MultiFormatWriter()).encode(contents, format, width, height);
         writeToFile(bitMatrix, filePostfix, file);
      } catch (Exception var8) {
         Exception e = var8;
         logger.error("QRCodeUtil捕获异常: ", e);
      }

   }

   public static void writeToFile(BitMatrix matrix, String format, File file) throws IOException {
      BufferedImage image = toBufferedImage(matrix);
      ImageIO.write(image, format, file);
   }

   public static BufferedImage toBufferedImage(BitMatrix matrix) {
      int width = matrix.getWidth();
      int height = matrix.getHeight();
      BufferedImage image = new BufferedImage(width, height, 2);

      for(int x = 0; x < width; ++x) {
         for(int y = 0; y < height; ++y) {
            image.setRGB(x, y, matrix.get(x, y) ? -16777216 : -1);
         }
      }

      return image;
   }

   public static void create_image(String smsInfo, String path) throws Exception {
      try {
         Qrcode testQrcode = new Qrcode();
         testQrcode.setQrcodeErrorCorrect('M');
         testQrcode.setQrcodeEncodeMode('B');
         testQrcode.setQrcodeVersion(7);
         String testString = smsInfo;
         BufferedImage bi = new BufferedImage(width, height, 12);
         Graphics2D g = bi.createGraphics();
         g.setBackground(Color.WHITE);
         g.clearRect(0, 0, width, height);
         g.setColor(Color.BLACK);
         byte[] d = testString.getBytes("gbk");
         if (d.length > 0 && d.length < 120) {
            boolean[][] s = testQrcode.calQrcode(d);

            for(int i = 0; i < s.length; ++i) {
               for(int j = 0; j < s.length; ++j) {
                  if (s[j][i]) {
                     g.fillRect(j * 2, i * 2, 2, 2);
                  }
               }
            }
         }

         g.dispose();
         bi.flush();
         String pathUrl = path + genVCode();
         File f = new File(pathUrl + "code.jpg");
         if (!f.exists()) {
            Boolean createNewFileFlag = f.createNewFile();
            if (createNewFileFlag) {
               logger.info("QRCodeUtil create_image: 文件创建成功");
            } else {
               logger.error("QRCodeUtil create_image: 文件创建失败");
            }
         }

         ImageIO.write(bi, "jpg", f);
      } catch (Exception var10) {
         Exception e = var10;
         logger.error("QRCodeUtil捕获异常: ", e);
      }

   }

   public static void main(String[] args) throws Exception {
      long start = System.currentTimeMillis();
      String string = "https://10.37.95.223/edealer_chs/app.html";
      String path = "";
      create_image(string, path);
      long end = System.currentTimeMillis();
      long last = end - start;
      System.out.println("time consume:" + last);
   }

   public static String genVCode() {
      Random rd = new Random();
      String vCode = "";

      for(int i = 0; i < 8; ++i) {
         vCode = vCode + String.valueOf(rd.nextInt(10));
      }

      return vCode;
   }
}
